Option Strict Off
Option Explicit On
Module Code
	
    'Public bBuffer(23) As Byte
    Public Buffer(23) As Byte
    Public lngChecksum As Long
	Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Integer)
	
    Public Sub vCalcChecksum()
        Dim x As Byte

        lngChecksum = 0
        'Add first 22 bytes for checksum
        For x = 0 To 21
            lngChecksum = lngChecksum + Buffer(x)
        Next
        'Now seperate the 16 bit value into two bytes
        lngChecksum = 65535 - lngChecksum 'Complement
        Buffer(22) = Int(lngChecksum / 256)
        Buffer(23) = (lngChecksum Mod 256)
    End Sub

    Public Sub ClearDataField()
        'Clears bytes (4) to (21) of the buffer which are considered as the data field part of the telegram
        'This is not absolutely necessary, since the data field may contain any data, as long as the checksum is correct
        'The extra data bytes are ignored then
        Dim x As Byte
        For x = 4 To 21
            Buffer(x) = 0
        Next
    End Sub
End Module